



function tmax=compute_max_step_PD(xrf,xrf_dir,tmax,opt,sar,spokes)
% function tmax=compute_max_step_PD(xrf,xrf_dir,tmax,opt,sar,spokes)

ncunk=size(xrf,1)/2;

rf=( xrf(1:ncunk)+1j*xrf(ncunk+1:end) ).';  % row vector
rf_dir=( xrf_dir(1:ncunk)+1j*xrf_dir(ncunk+1:end) ).';  % row vector

nconst=sar.nvop+1;
ts=zeros(nconst+2,1);
for i=1:nconst
    Q=kron( eye(spokes.nspokes),squeeze(sar.sarmats(i,:,:)) ).*spokes.C;
    
    A=real( rf_dir*Q*rf_dir' );
    B=2*real( rf*Q*rf_dir' );
    C=real( rf*Q*rf' );
    if i==nconst
        C=C-sar.gsarmax;
    else
        C=C-sar.lsarmax;
    end
    
    if C>0
        error('C cannot be positive (unfeasible point)');
    end  
          
    delta=B^2-4*A*C;
    if delta<0
        error('Quadratic equation does not have real solutions.');
    end
    
    ts(i)=( -B+sqrt(delta) )/2/A;
end

A=abs(rf_dir).^2;
B=2*real( rf_dir.*conj(rf) );
C=abs(rf).^2 - sar.ppmax*8.0*50.0;
if C>0
    error('C cannot be positive (unfeasible point)');
end
delta=B.^2-4*A.*C;
if ~isempty(find(delta<0))
    error('Quadratic equation does not have real solutions.');
end
ts(nconst+1)=min( ( -B+sqrt(delta) )./(2*A) );

ts(end)=tmax;

% select the most constraining of all tmax
tmax=min(ts);





















