

function [A_noRF sinc_a sinc_b A_noRF_noTS]=compute_system_matrix_deltat(opt,system,spokes,deltat,b0off)
% function [A_noRF sinc_a sinc_b A_noRF_noTS]=compute_system_matrix_deltat(opt,system,spokes,deltat,b0off)

gamma=42.576*1e6;

mid_spoke_index=ceil( (spokes.sinc_time_and_spoke_to_time(1,1)+spokes.sinc_time_and_spoke_to_time(end,1))/2 );
Gss=abs( spokes.g(mid_spoke_index,3) );    
K=1j*2*pi/( Gss*spokes.sthick );  % constant factor

g=-opt.B0_slice_grad(opt.ind)/gamma;  % the factor of gamma converts the B0 slice gradient from Hz/m to T/m ******* WHY IS THERE A MINUS SIGN???? *********

A_noRF=zeros(opt.nnonzeropixels,spokes.nspokes*system.ncoils);
if nargout>3
    A_noRF_noTS=zeros(opt.nnonzeropixels,spokes.nspokes*system.ncoils);
end

sinc_a=-pi*gamma*Gss*spokes.sthick;
sinc_b=zeros(opt.nnonzeropixels,spokes.nspokes);
for sp=1:spokes.nspokes
    
    mid_spoke_index=ceil( (spokes.sinc_time_and_spoke_to_time(1,sp)+spokes.sinc_time_and_spoke_to_time(end,sp))/2 );
    Gss_pola=sign( spokes.g(mid_spoke_index,3) );
    
    % T0=( spokes.sinc_time_and_spoke_to_time(1,sp)+spokes.sinc_time_and_spoke_to_time(end,sp) )/2*system.deltat;  % mid time point of the current spoke kz traversal (kz=0)
    T0=spokes.T_mid_spoke(sp);
    
    ktrans=spokes.k( spokes.sinc_time_and_spoke_to_time(1,sp),1:2 );  % spokes location in transverse k-space    
    exp_1=( opt.B0_+b0off ).*Gss_pola*Gss*( opt.TE-T0 )./( Gss_pola*Gss-g );
    sinc_b(:,sp)=pi*gamma*Gss*spokes.sthick.*g*( opt.TE-T0 )./( Gss_pola*Gss-g );    
    
    for chn=1:system.ncoils
        sinc_1=sinc_a*deltat(chn+(sp-1)*system.ncoils) + sinc_b(:,sp);
        A_noRF( :,chn+(sp-1)*system.ncoils )=K*opt.b1maps_(:,chn).* exp( 1j*2*pi*opt.nonzeropixels(:,4:5)*ktrans' ).*exp( -1j*2*pi*exp_1 ).*sinc( sinc_1/pi );  % no RF, with time shift    
        if nargout>3
            A_noRF_noTS( :,chn+(sp-1)*system.ncoils )=K*opt.b1maps_(:,chn).* exp( 1j*2*pi*opt.nonzeropixels(:,4:5)*ktrans' ).*exp( -1j*2*pi*exp_1 );  % no RF, no time shift 
        end
    end
end

