




function [xrf mtt mttimg f0]=design_pulse_MLS(opt,A,spokes,sar,xrf0,tol_LS_inner,tol_MLS,tol_LS_final,niters_MLS,disp,fast)
% function [xrf mtt mttimg f0]=design_pulse_MLS(opt,A,spokes,sar,xrf0,tol_LS_inner,tol_MLS,tol_LS_final,niters_MLS,disp,fast)

global pha;
global phaimg;
global smfilter;

% smfilter=fspecial('gaussian',[10 10],3);  % 5 pixels Gaussian filter with 1 pixel s.d.
smfilter=ones(5)/25;  % moving average

ncunk=size(A,2);
iter=0;
phaimg=zeros(opt.nx,opt.ny,opt.nz);
update_target_phase(A,ncunk,xrf0,opt.ind);
mtt=abs(opt.mtt).*exp(1j*pha);
opt.mtt=mtt;
mttimg=abs(opt.mttimg).*exp(1j*phaimg);

if disp==1
    f=figure;
    imagesc( reshape(phaimg,opt.nx,opt.ny) ); colormap(hot); axis off; axis image; caxis([-pi pi]);
    axes('Units','Normal','Position',[.075 .075 .85 .85],'Visible','off'); set(get(gca,'Title'),'Visible','on'); title(sprintf('Target phase (MLS it. #%d)',iter));
end

f1=-1;
f2=-1;
while iter<=niters_MLS || f1<0 || f2<0
    
    iter=iter+1;
    
    if fast
        % LS (no constaints)
        rf0=xrf0(1:ncunk) + 1j*xrf0(ncunk+1:end);
        [rf flag]=lsqr(A,opt.mtt,tol_LS_inner,5000,[],[],rf0);
        xrf=[ real(rf);imag(rf) ];
        f2=f0_LS(xrf,A,opt);
    else
        % LS (primal-dual)
        [xrf lambda f2 df0 c dc]=primal_dual( xrf0,@(xrf)f0_LS(xrf,A,opt),@(xrf)fn(xrf,opt,spokes,sar,2), ...
            @(xrf,lambda)dualhess_LS(xrf,lambda,A,opt,spokes,sar,2),5000,tol_LS_inner,disp,@(xrf,xrf_dir,tmax)compute_max_step_PD(xrf,xrf_dir,tmax,opt,sar,spokes) );
    end
    
    % iterations statement
    if disp==1
        fprintf('\tMLS it. #%d: f=%e\n',iter,f2);
    end
       
    % update target magnetization phase
    update_target_phase(A,ncunk,xrf,opt.ind);
    mtt=abs(opt.mtt).*exp(1j*pha);
    opt.mtt=mtt;
    mttimg=abs(opt.mttimg).*exp(1j*phaimg);
    
    % display
    if disp==1
        figure(f);
        imagesc( reshape(phaimg,opt.nx,opt.ny ) ); colormap(hot); axis off; axis image; caxis([-pi pi]);
        axes('Units','Normal','Position',[.075 .075 .85 .85],'Visible','off'); set(get(gca,'Title'),'Visible','on'); title(sprintf('Target phase (MLS it. #%d)',iter));
    end
    
    % stopping criterion
    if f1>0 && f2>0 && ( abs(f1-f2)<(abs(f1)+abs(f2))*tol_MLS || f2>f1 )
        break;
    end
    
    f1=f2;
end

if fast
    % LS (no constaints)
    [rf flag]=lsqr(A,opt.mtt,tol_LS_final,5000,[],[],rf0);
    xrf=[ real(rf);imag(rf) ];
    f0=f0_LS(xrf,A,opt);
else
    % last LS (primal-dual)
    [xrf lambda f0 df0 c dc]=primal_dual( xrf,@(xrf)f0_LS(xrf,A,opt),@(xrf)fn(xrf,opt,spokes,sar,2), ...
        @(xrf,lambda)dualhess_LS(xrf,lambda,A,opt,spokes,sar,2),5000,tol_LS_final,disp,@(xrf,xrf_dir,tmax)compute_max_step_PD(xrf,xrf_dir,tmax,opt,sar,spokes) );
end


function update_target_phase(A,ncunk,xrf,ind)

global pha;
global phaimg;
global smfilter;

rf=xrf(1:ncunk) + 1j*xrf(ncunk+1:2*ncunk);
y=A*rf;
phaimg(ind)=angle(y);

% for k=1:size(phaimg,3)
%     phaimg(:,:,k)=imfilter(phaimg(:,:,k),smfilter);
% end

pha=phaimg(ind);


function img_sm=smooth(img)

img_sm=ifftn( fftn(img).*ker_fft_fftshift );












