

function [gsar lsar pp]=display_optimization_summary(rf,rf2,opt,spokes,sar,system,duty_cycle)
% function [gsar lsar pp]=display_optimization_summary(rf,rf2,opt,spokes,sar,system,duty_cycle)

ncunk=size(rf,1);
xrf=[real(rf);imag(rf)];
[c ceq dc dceq]=fn(xrf,opt,spokes,sar,system,1);

% SAR
if sar.nvop>0
    [lsar vopind]=max( c(1:sar.nvop,1)+sar.lsarmax );
else
    lsar=0;
    vopind=0;
end

if sar.nvop+1>0
    gsar=c(sar.nvop+1,1) + sar.gsarmax;
else
    gsar=0;
end

fprintf('\tThe estimated local SAR for this set of pulses is %e W/kg (VOP #%d)\n',lsar*duty_cycle,vopind);
fprintf('\tGocal SAR for this set of pulses is %e W/kg\n',gsar*duty_cycle);

% power
pp=abs(rf2).^2/(8.0*50.0);
for i=1:system.ncoils
    fprintf('\tChn. #%d:\tav. power=%f W\tmax. power=%f W\n',i,mean(pp(:,i)),max(pp(:,i)));
end    


