


function h=dualhess_MLS(xrf,lambda,A,opt,spokes,sar,solver,do_mls)
% function h=dualhess_MLS(xrf,lambda,A,opt,spokes,sar,solver,do_mls)

[npix ncunk]=size(A);
nchannels=ncunk/spokes.nspokes;

% HESSIAN OF OBJ FUNCTION
rf=xrf(1:ncunk) + 1j*xrf(ncunk+1:end);
MT=A*rf;

if do_mls
    y=abs(MT) - abs(opt.mtt);
    z=sqrt( abs(opt.mtt)./abs(MT) ) .* exp(1j*angle(MT));
    w=y./abs(MT);
    
    z( abs(MT)==0 )=0;
    w( abs(MT)==0 )=0;
    
    % X=A'*diag(z);
    X=A'.*repmat(z.',[ncunk 1]);  % faster
    
    % Y=A'*diag(w)*A;
    Y=( A'.*repmat(w.',[ncunk 1]) )*A;  % faster
    
    h11=2*real(X)*real(X)' + 2*real(Y);
    h12=2*real(X)*imag(X)' - 2*imag(Y);
    h21=h12';
    h22=2*imag(X)*imag(X)' + 2*real(Y);
    
    h_OBJ=[ h11 h12;h21 h22 ];
else
    ch=2.0*A'*A;
    h_OBJ=[real(ch) -imag(ch);imag(ch) real(ch)];
end

if solver==1  % Matlab solver
    LagMult=lambda.ineqnonlin;
else
    LagMult=lambda;
end

% % HESSIAN OF SAR CONSTRAINTS
% subh=zeros(nchannels,nchannels);
% nconst=sar.nvop+1;
% for n=1:nconst
%     subh(:,:)=subh(:,:) + 2.0*LagMult(n)*squeeze( sar.sarmats(n,:,:) );    
% end
% ch=kron( eye(spokes.nspokes),subh ).*(spokes.C);
% h_SAR=[real(ch) -imag(ch)';imag(ch)' real(ch)];

% HESSIAN OF MAX POWER CONSTRAINTS
% tmp=LagMult(nconst+1:nconst+ncunk);
tmp=LagMult(1:ncunk);
tmp=[tmp;tmp]; % real and imaginary
h_MAX_CONS=2.0*diag(tmp);

h=h_OBJ + h_MAX_CONS;





