

function h=dualhess_LS(xrf,lambda,A,opt,spokes,sar,solver)
% function h=dualhess_LS(xrf,lambda,A,opt,spokes,sar,solver)

nchannels=size(opt.b1maps,1);
ncunk=spokes.nspokes*nchannels;
nconst=sar.nvop+1;

% Hessian of the main function
ch=2.0*A'*A;
h=[real(ch) -imag(ch);imag(ch) real(ch)];

if solver==1  % Matlab solver
    LagMult=lambda.ineqnonlin;
else
    LagMult=lambda;
end

% Hessian of the constraints (SAR)
subh=2*squeeze( sum( sar.sarmats .* repmat(LagMult(1:nconst),[1 nchannels nchannels]),1 ) );
ch=kron( eye(spokes.nspokes),subh ).*(spokes.C);
h=h+[real(ch) -imag(ch)';imag(ch)' real(ch)];

% Hessian of the constraints (max. power)
tmp=LagMult(nconst+1:nconst+ncunk);
tmp=[tmp;tmp]; % real and imaginary
h=h+2.0*diag(tmp);


