


function h=dualhess_MLS(xrf,lambda,A,opt,spokes,sar,solver)
% function h=dualhess_MLS(xrf,lambda,A,opt,spokes,sar,solver)

[npix ncunk]=size(A);
nchannels=ncunk/spokes.nspokes;

% Hessian of the main function
rf=xrf(1:ncunk) + 1j*xrf(ncunk+1:end);
MT=A*rf;

y=abs(MT) - abs(opt.mtt);
z=sqrt( abs(opt.mtt)./abs(MT) ) .* exp(1j*angle(MT));
w=y./abs(MT);

z( abs(MT)==0 )=0;
w( abs(MT)==0 )=0;

% X=A'*diag(z);
X=A'.*repmat(z.',[ncunk 1]);  % faster

% Y=A'*diag(w)*A;
Y=( A'.*repmat(w.',[ncunk 1]) )*A;  % faster

h11=2*real(X)*real(X)' + 2*real(Y);
h12=2*real(X)*imag(X)' - 2*imag(Y);
h21=h12';
h22=2*imag(X)*imag(X)' + 2*real(Y);

h=[ h11 h12;h21 h22 ];

if solver==1  % Matlab solver
    LagMult=lambda.ineqnonlin;
else
    LagMult=lambda;
end

% Hessian of the constraints (SAR)
nconst=sar.nvop+1;
if nconst>0
    subh=2*squeeze( sum( sar.sarmats .* repmat(LagMult(1:nconst),[1 nchannels nchannels]),1 ) );
    ch=kron( eye(spokes.nspokes),subh ).*(spokes.C);
    h=h+[real(ch) -imag(ch)';imag(ch)' real(ch)];
end

% Hessian of the constraints (max. power)
tmp=LagMult(nconst+1:nconst+ncunk);
% tmp=LagMult(1:ncunk);
tmp=[tmp;tmp]; % real and imaginary
h=h+2.0*diag(tmp);





