



function [f df]=f0_gr(x_gr,opt,spokes,system,sar,deltat)
% function [f df]=f0_gr(x_gr,opt,spokes,system,sar,deltat)

spokes2=spokes;
nsp=spokes2.nspokes;
nchannels=size(opt.b1maps,1);
ncunk=nsp*nchannels;

% retrieve spokes coordinates and coeficients from "x"
for i=1:spokes.nspokes
    spokes2.spcoords(i,1)=x_gr( (i-1)*2+1,1 );
    spokes2.spcoords(i,2)=x_gr( (i-1)*2+2,1 );
end

% system matrix
spokes2=prepare_pulse(spokes2,system);
opt.A=compute_system_matrix(opt,system,spokes2,deltat);

% compute rf
options = optimset('Largescale','off','Display','none','MaxFunEvals',10^5,'TolFun',1e-6,'TolCon',1e-6,'MaxIter',5000,...
    'Algorithm','interior-point','Hessian','user-supplied','HessFcn',@(xrf,lambda)dualhess(xrf,lambda,opt.A,opt,spokes2,sar),...
    'GradObj','on','GradConstr','on','SubproblemAlgorithm','ldl-factorization');
xrf0=zeros( 2*ncunk,1 );
[xrf fval exitflag output lambda]=fmincon(@(xrf)f0(xrf,opt.A,opt),xrf0,[],[],[],[],[],[],@(xrf)fn(xrf,opt,spokes2,sar),options); 

% compute f
rf=xrf(1:ncunk,1) + 1j*xrf(ncunk+1:end,1);
y=opt.A*rf-opt.mtt;
f=real(y'*y);

% compute df (gradient)
if nargout>1
    df=zeros(2*nsp,1);
    for sp=1:nsp
        tmp=sum( opt.A(:,(sp-1)*nchannels+1:sp*nchannels).'.*repmat( rf((sp-1)*nchannels+1:sp*nchannels,1),1,opt.nnonzeropixels ),1 );
        df( 2*(nsp-sp)+1,1 )=2.0*sum( real( 2*pi*1j*opt.nonzeropixels(:,4).*tmp.'.*conj(y)),1 );
        df( 2*(nsp-sp)+2,1 )=2.0*sum( real( 2*pi*1j*opt.nonzeropixels(:,5).*tmp.'.*conj(y)),1 );    
    end
end




