

function [f df MT]=f0_jointRFDeltat(x,A_noRF_noTS,sinc_a,sinc_b_large,spokes,opt,do_mls)
% function [f df MT]=f0_jointRFDeltat(x,A_noRF_noTS,sinc_a,sinc_b_large,spokes,opt,do_mls)

[npix ncunk]=size(A_noRF_noTS);
nchannels=ncunk/spokes.nspokes;

deltat=x(1:ncunk);
xrf=x(ncunk+1:end);
rf=xrf(1:ncunk) + 1j*xrf(ncunk+1:end);

% function
A_noTS=A_noRF_noTS .* repmat(rf.',[npix 1]);
x=repmat( sinc_a*deltat',[npix 1] ) + sinc_b_large;
sincx=sinc(x/pi);

MT=sum( A_noTS.*sincx,2 );

if do_mls
    y=abs(MT) - abs(opt.mtt);
    f=y'*y;
else
    y=MT - opt.mtt;
    f=y'*y;
end

df=[];

% derivative
if nargout>1
    
    % wrt time-shifts
    dx=sinc_a*( cos(x)./x-sin(x)./(x.^2) );
    dx( find(abs(x)==0) )=0;
    K=A_noTS.*dx;
    
    if do_mls
        df=2.0*real( K'*( y.*exp(1j*angle(MT)) ) );
    else
        df=2.0*real( K'*y );
    end
    
    % wrt RF
    A_noRF=A_noRF_noTS.*sincx;
    if do_mls
        cdf=2.0*A_noRF'*( y.*exp(1j*angle(MT)) );
        df=[ df;[real(cdf);imag(cdf)] ];
    else
        cdf=2.0*A_noRF'*y;
        df=[ df;[real(cdf);imag(cdf)] ];
    end
    
end













