



function [a b c d clim]=fn(xrf,opt,spokes,sar,system,solver)
% function [a b c d clim]=fn(xrf,opt,spokes,sar,system,solver)

% no equality constraints
ceq=[];
dceq=[];

% inequality constraints (SAR)
ncunk=size(xrf,1)/2;
rf=reshape( xrf(1:ncunk) + 1j*xrf(ncunk+1:2*ncunk),1,ncunk );

nconst=sar.nvop+1;
c=zeros(nconst,1);

if ( solver==1 & nargout>2) | ( solver==2 & nargout>1 )
    dc=zeros(2*ncunk,nconst);
else
    dc=[];
end

for i=1:nconst
    tmp=( kron( eye(spokes.nspokes),squeeze(sar.sarmats(i,:,:))).*spokes.C )*rf';
    if i==nconst
        c(i)=real( rf*tmp ) - sar.gsarmax;
    else
        c(i)=real( rf*tmp ) - sar.lsarmax;
    end
    
    if ( solver==1 & nargout>2) | ( solver==2 & nargout>1 )
        dc(1:ncunk,i)=2*real(tmp);
        dc(ncunk+1:2*ncunk,i)=-2*imag(tmp);
    end
end

% inequality constraints (max. power)
xsqmax=system.vmax^2;
c=[ c;abs(rf.').^2-xsqmax ];
if ( solver==1 & nargout>2) | ( solver==2 & nargout>1 )
    dc=[ dc [2*real(diag(rf(1,:)));2*imag(diag(rf(1,:)))] ];
end

if nargout>4
    clim=ones(nconst-1,1)*sar.lsarmax;
    clim=[ clim;sar.gsarmax ];
    clim=[ clim;ones(ncunk,1)*xsqmax ];
end

if solver==1  % matlab fmincon
    a=c;
    b=ceq;
    c=dc;    
    d=dceq;
else  % primal-dual
    a=c;
    b=dc;
    c=ceq;
    d=dceq;
end




