


function [a b c d clim]=fn(deltat,deltat_max,xrf,opt,spokes,sar,system,solver)
% function [a b c d clim]=fn(deltat,deltat_max,xrf,opt,spokes,sar,system,solver)

spokes=time_shift_sinc_profiles(spokes,deltat*1e-6,system);

% no equality constraints
ceq=[];
dceq=[];

% inequality constraints (SAR)
nchannels=size(opt.b1maps_,2);
ncunk=size(xrf,1)/2;
nconst=sar.nvop+1;
rf=reshape( xrf(1:ncunk) + 1j*xrf(ncunk+1:2*ncunk),1,ncunk );
c=zeros(nconst,1);

if ( solver==1 & nargout>2) | ( solver==2 & nargout>1 )
    dc=zeros(ncunk,nconst);
else
    dc=[];
end

for i=1:nconst
    Q=kron(eye(spokes.nspokes),squeeze(sar.sarmats(i,:,:))).*(spokes.C);
    tmp2=Q*rf';
    c(i)=real( rf*tmp2 );
    if i==nconst
        c(i)=c(i) - sar.gsarmax;
    else
       c(i)=c(i) - sar.lsarmax;
    end
    
    if ( solver==1 & nargout>2) | ( solver==2 & nargout>1 )        
        DQ=kron(eye(spokes.nspokes),squeeze(sar.sarmats(i,:,:))).*(spokes.DC);
        tmp2=(rf.').*( DQ*rf' );
        dc(:,i)=2*real(tmp2)*1e-6;
    end
end

% maximum time shift
xsqmax=deltat_max^2;
c=[ c;deltat.^2-xsqmax ];

if ( solver==1 & nargout>2) | ( solver==2 & nargout>1 )
    dc=[ dc 2*diag(deltat) ];
end

if nargout>4
    clim=ones(nconst-1,1)*sar.lsarmax;
    clim=[ clim;sar.gsarmax ];
    clim=[ clim;ones(ncunk,1)*xsqmax ];
end

if solver==1  % matlab fmincon
    a=c;
    b=ceq;
    c=dc;    
    d=dceq;
else  % primal-dual
    a=c;
    b=dc;
    c=ceq;
    d=dceq;
end
















