



function [a b c d clim]=fn_jointRFDeltat(x,deltat_max,opt,spokes,sar,system,solver)
% function [a b c d clim]=fn_jointRFDeltat(x,deltat_max,opt,spokes,sar,system,solver)

ncunk=system.ncoils*spokes.nspokes;

deltat=x(1:ncunk);
xrf=x(ncunk+1:end);
rf=( xrf(1:ncunk)+1j*xrf(ncunk+1:end) ).';  % row vector

spokes=time_shift_sinc_profiles(spokes,deltat*1e-6,system);

% no equality constraints
ceq=[];
dceq=[];

% inequality constraints (SAR)
rf=reshape( xrf(1:ncunk) + 1j*xrf(ncunk+1:2*ncunk),1,ncunk );

nconst=sar.nvop+1;
c=zeros(nconst,1);
if ( solver==1 & nargout>2) | ( solver==2 & nargout>1 )
    dc=zeros(3*ncunk,nconst);
else
    dc=[];
end

for i=1:nconst
    Q=kron(eye(spokes.nspokes),squeeze(sar.sarmats(i,:,:))).*(spokes.C);
    tmp2=Q*rf';
    c(i)=real( rf*tmp2 );
    if i==nconst
        c(i)=c(i) - sar.gsarmax;
    else
        c(i)=c(i) - sar.lsarmax;
    end
    
    if ( solver==1 & nargout>2) | ( solver==2 & nargout>1 )
        % derivative wrt time-shifts
        DQ=kron(eye(spokes.nspokes),squeeze(sar.sarmats(i,:,:))).*(spokes.DC);
        tmp=(rf.').*( DQ*rf' );
        dc(1:ncunk,i)=2*real(tmp)*1e-6;
        
        % derivative wrt RF
        dc(ncunk+1:end,i)=2*[ real(tmp2);-imag(tmp2) ];
    end
end

% inequality constraints (maximum time shift)
xsqmax=deltat_max^2;
c=[ c;deltat.^2-xsqmax ];
if ( solver==1 & nargout>2) | ( solver==2 & nargout>1 )
    dc=[ dc [2*diag(deltat);zeros(2*ncunk,ncunk)] ];
end

% inequality constraints (max. power)
xsqmax=system.vmax^2; 
c=[ c;abs(rf.').^2-xsqmax ];
if ( solver==1 & nargout>2) | ( solver==2 & nargout>1 )
    dc=[ dc [zeros(ncunk);2*real(diag(rf(1,:)));2*imag(diag(rf(1,:)))] ];
end

if nargout>4
    clim=ones(nconst-1,1)*sar.lsarmax;
    clim=[ clim;sar.gsarmax ];
    clim=[ clim;ones(ncunk,1)*xsqmax ];
end

if solver==1  % matlab fmincon
    a=c;
    b=ceq;
    c=dc;    
    d=dceq;
else  % primal-dual
    a=c;
    b=dc;
    c=ceq;
    d=dceq;
end




































