

function deltat=initialize_time_shifts_rand(spokes,opt,deltat_max,xrf0,system,sar,do_mls,A_noRF_noTS,sinc_a,sinc_b)
% function deltat=initialize_time_shifts_rand(spokes,opt,deltat_max,xrf0,system,sar,do_mls,A_noRF_noTS,sinc_a,sinc_b)

[npix ncunk]=size(A_noRF_noTS);
nchannels=opt.nrows*opt.ncoilspr;
deltat=zeros(nchannels*spokes.nspokes,1);

sinc_b_large=[];
for i=1:spokes.nspokes
    sinc_b_large=[ sinc_b_large repmat(sinc_b(:,i),[1 nchannels]) ];
end

if sum(abs(xrf0))==0
    options = optimset('Largescale','off','Display','iter-detailed','MaxFunEvals',10^5,'TolFun',1e-6,'TolCon',1e-6,'MaxIter',5000,...
        'Algorithm','interior-point','GradObj','on','GradConstr','on','SubproblemAlgorithm','ldl-factorization','Display','none' );

    x=repmat( sinc_a*deltat',[npix 1] ) + sinc_b_large;
    sincx=sinc(x/pi);
    A_noRF=A_noRF_noTS.*sincx;
    [xrf0 f0 exitflag output lambda]=fmincon( @(xrf)f0_MLS(xrf,A_noRF,opt),xrf0,[],[],[],[],[],[],@(xrf)fn(xrf,opt,spokes,sar,1),options );
end

options = optimset('Largescale','off','Display','iter-detailed','MaxFunEvals',10^5,'TolFun',1e-6,'TolCon',1e-6,'MaxIter',20,...
    'Algorithm','interior-point','GradObj','on','GradConstr','on','SubproblemAlgorithm','ldl-factorization','Display','none',...
    'Hessian','user-supplied','HessFcn',@(x,lambda)dualhess_jointRFDeltat(x,lambda,A_noRF_noTS,sinc_a,sinc_b_large,opt,spokes,sar,system,1) );

nshells=5;
npointspershell=10;
npoints=nshells*npointspershell;
deltat_max_shells=linspace(0,deltat_max,nshells+1)';

deltat_allshells=zeros(ncunk,npoints);
err_allshells=zeros(npoints,1);
sbuf=[];
nn=1;
for n=1:nshells
    fprintf('\tShell %d out of %d ',n,nshells);
    
    for i=1:npointspershell
        
        if n==1 && i==1
            deltat_allshells(:,nn)=zeros(ncunk,1);
        else
            deltat_allshells(:,nn)=( rand(ncunk,1)-0.5 )*2*deltat_max_shells(n+1);
        end
        
        x0=[deltat_allshells(:,nn)*1e6;xrf0];  % s -> us
        [x f0 exitflag output lambda]=fmincon( @(x)f0_jointRFDeltat(x,A_noRF_noTS,sinc_a*1e-6,sinc_b_large,spokes,opt,do_mls),x0, ...
            [],[],[],[],[],[],@(x)fn_jointRFDeltat(x,deltat_max*1e6,opt,spokes,sar,system,1),options );
        
        err_allshells(nn)=f0;
        
        for j=1:size(sbuf,2)
            fprintf('\b');
        end
        sbuf=sprintf('[%d/%d: deltat_max=%f us  f0=%f]',i,npointspershell,deltat_max_shells(n+1)*1e6,f0);
        fprintf(sbuf);
        
        nn=nn+1;
    end
    
    ind_shell=[1:npointspershell]' + (n-1)*npointspershell;
    val=min(err_allshells(ind_shell));
    
    for j=1:size(sbuf,2)
        fprintf('\b');
    end
    sbuf=sprintf('[deltat_max=%f us  f0=%f]',deltat_max_shells(n+1)*1e6,val);
    fprintf(sbuf);
    
    fprintf('\n');
    sbuf=[];    
end

[val ind]=min(err_allshells);
deltat=deltat_allshells(:,ind);


% sigma_generator=deltat_max;
% tmin=2.508583e-004; tmax=1;
% report=2;
% options_sa = struct(...
%         'CoolSched',@(T) (T*0.6),...
%         'Generator',@(x) (x(:)'+(randperm(length(x))==length(x))*randn*sigma_generator)',...
%         'InitTemp',tmax,...
%         'MaxConsRej',1000,...
%         'MaxSuccess',20,...
%         'MaxTries',300,...
%         'StopTemp',tmin,...
%         'StopVal',-Inf,...
%         'Verbosity',report);
%     
% do_mls=0;
% [xsa fsa]=anneal( @(deltat)optimize_RF_fixed_time_shifts(deltat,xrf0,do_mls,spokes,opt,system,sar,1e-6,0,0),zeros(nchannels,1),options_sa );












