


function [f0 xrf MT opt]=optimize_RF_fixed_time_shifts_DirectMLSMin(deltat,xrf0,A_noRF_noTS,sinc_a,sinc_b_large,spokes,opt,system,do_mls,sar,tol,disp)
% function [f0 xrf MT opt]=optimize_RF_fixed_time_shifts_DirectMLSMin(deltat,xrf0,A_noRF_noTS,sinc_a,sinc_b_large,spokes,opt,system,do_mls,sar,tol,disp)

options = optimset('Largescale','off','Display','iter-detailed','MaxFunEvals',10^5,'TolFun',tol,'TolCon',tol,'MaxIter',5000,...
    'Algorithm','interior-point','GradObj','on','GradConstr','on','SubproblemAlgorithm','ldl-factorization');

if disp==1
    options.Display='iter-detailed';
else
    options.Display='none';
end

[npix ncunk]=size(A_noRF_noTS);
nchannels=ncunk/spokes.nspokes;

x=repmat( sinc_a*deltat',[npix 1] ) + sinc_b_large;
sincx=sinc(x/pi);
A_noRF=A_noRF_noTS.*sincx;

% test_grad( @(xrf)f0_MLS(xrf,A_noRF,opt),xrf0 );
% test_grad( @(xrf)fn(xrf,opt,spokes,sar,2),xrf0 );

fprintf('Optimizing RF @ constant time-shifts  ');

if do_mls
    options.Hessian='user-supplied';
    options.HessFcn=@(xrf,lambda)dualhess_MLS(xrf,lambda,A_noRF,opt,spokes,sar,1);
    [xrf f0 exitflag output lambda]=fmincon( @(xrf)f0_MLS(xrf,A_noRF,opt),xrf0,[],[],[],[],[],[],@(xrf)fn(xrf,opt,spokes,sar,system,1),options );
else
    options.Hessian='user-supplied';
    options.HessFcn=@(xrf,lambda)dualhess_LS(xrf,lambda,A_noRF,opt,spokes,sar,1);    
    [xrf f0 exitflag output lambda]=fmincon( @(xrf)f0_LS(xrf,A_noRF,opt),xrf0,[],[],[],[],[],[],@(xrf)fn(xrf,opt,spokes,sar,system,1),options );
end

fprintf('(f0=%f)\n',f0);

rf=xrf(1:ncunk) + 1j*xrf(ncunk+1:end);
MT=A_noRF*rf;

opt.mtt=abs(opt.mtt) .* exp( 1j*angle(MT) );





















