


function [f0 xrf MT opt]=optimize_RF_fixed_time_shifts_PhaseAdapt(deltat,xrf0,do_mls,spokes,opt,system,sar,tol,disp,fast)
% function [f0 xrf MT opt]=optimize_RF_fixed_time_shifts_PhaseAdapt(deltat,xrf0,do_mls,spokes,opt,system,sar,tol,disp,fast)

% compute sub-pulses for this deltat
spokes_=time_shift_sinc_profiles(spokes,deltat,system);

% slice-averaged STA system matrix
A=compute_system_matrix_deltat(opt,system,spokes_,deltat);

% test_grad( @(xrf)f0_LS(xrf,A,opt),xrf0 );
% test_grad( @(xrf)fn(xrf,opt,spokes_,sar,1),xrf0 );
% test_hessian( @(xrf)f0_LS(xrf,A,opt),@(xrf,lambda)dualhess_LS(xrf,ones(1e5,1),A,opt,spokes_,sar,1),xrf0 );
% test_hessian( @(xrf)fn(xrf,opt,spokes_,sar,1),@(xrf,lambda)dualhess_LS(xrf,ones(1e5,1),A,opt,spokes_,sar,2),xrf0 );

if fast  % NO CONSTRAINTS
    
    if do_mls==1
        [xrf mtt mttimg f0]=design_pulse_MLS(opt,A,spokes_,sar,xrf0,1e-6,1e-3,1e-6,2,disp,1);
        opt.mtt=mtt;
        opt.mttimg=mttimg;
        
    else
        ncunk=size(A,2);
        rf0=xrf0(1:ncunk) + 1j*xrf0(ncunk+1:end);
        [rf flag]=lsqr(A,opt.mtt,tol,5000,[],[],rf0);
        xrf=[ real(rf);imag(rf) ];
        f0=f0_LS(xrf,A,opt);
    end    
    
else  % WITH CONSTRAINTS
    
    if do_mls==1
        [xrf mtt mttimg f0]=design_pulse_MLS(opt,A,spokes_,sar,xrf0,1e-6,1e-3,1e-6,2,disp,0);  % limit to 2 steps MLS to avoid phase curls
        opt.mtt=mtt;
        opt.mttimg=mttimg;
    else
        [xrf lambda f0 df0 c dc]=primal_dual( xrf0,@(xrf)f0_LS(xrf,A,opt),@(xrf)fn(xrf,opt,spokes_,sar,2), ...
            @(xrf,lambda)dualhess_LS(xrf,lambda,A,opt,spokes_,sar,2),5000,tol,disp,@(xrf,xrf_dir,tmax)compute_max_step_PD(xrf,xrf_dir,tmax,opt,sar,spokes_) );
    end
    
end

if nargout>2
    ncunk=size(A,2);
    rf=xrf(1:ncunk) + 1j*xrf(ncunk+1:end);
    MT=A*rf;
end









