


function [deltat fval]=optimize_time_shifts_fixed_RF(deltat,xrf,do_mls,A_noRF_noTS,sinc_a,sinc_b,sinc_b_large,deltat_max,opt,spokes,sar,system,tol,disp)
% function [deltat fval]=optimize_time_shifts_fixed_RF(deltat,xrf,do_mls,A_noRF_noTS,sinc_a,sinc_b,sinc_b_large,deltat_max,opt,spokes,sar,system,tol,disp)

options = optimset('Largescale','off','Display','iter-detailed','MaxFunEvals',10^5,'TolFun',tol,'TolCon',tol,'MaxIter',100,...
    'Algorithm','interior-point','GradObj','on','GradConstr','on','SubproblemAlgorithm','ldl-factorization');

if disp==1
    options.Display='iter-detailed';
else
    options.Display='none';
end

[npix ncunk]=size(A_noRF_noTS);
rf=xrf(1:ncunk) + 1j*xrf(ncunk+1:end);
A_noTS=A_noRF_noTS .* repmat(rf.',[npix 1]);  % incorporates effect of RF but not time shifts

deltat0=deltat*1e6;
deltat_max2=deltat_max*1e6;
sinc_a2=sinc_a*1e-6;

% test_grad( @(deltat)fn_deltat(deltat,deltat_max,xrf,opt,spokes,sar,system,2),deltat0 );
% test_grad( @(deltat)f0_deltat(deltat,A_noTS,sinc_a2,sinc_b_large,do_mls,opt),deltat0 );
% lambda=ones(1e5,1);
% test_hessian( @(deltat)f0_deltat(deltat,A_noTS,sinc_a2,sinc_b_large,do_mls,opt),@(deltat)dualhess_deltat(deltat,lambda,xrf,A_noRF_noTS,sinc_a2,sinc_b_large,opt,spokes,sar,system,2),deltat0 );
% test_hessian( @(deltat)fn_deltat(deltat,deltat_max,xrf,opt,spokes,sar,system,2),@(deltat)dualhess_deltat(deltat,lambda,xrf,A_noRF_noTS,sinc_a2,sinc_b_large,opt,spokes,sar,system,2),deltat0 );

fprintf('Optimizing time-shifts @ constant RF  ');

options.Hessian='user-supplied';
options.HessFcn=@(x,lambda)dualhess_deltat(x,lambda,xrf,A_noRF_noTS,sinc_a2,sinc_b_large,opt,spokes,sar,system,1);

% options.Hessian='';

[deltat fval exitflag output lambda]=fmincon( @(deltat)f0_deltat(deltat,A_noTS,sinc_a2,sinc_b_large,do_mls,opt),deltat0, ...
    [],[],[],[],[],[],@(deltat)fn_deltat(deltat,deltat_max2,xrf,opt,spokes,sar,system,1),options );

deltat=deltat*1e-6;

fprintf('(f0=%f)\n',fval);










