

function opt2=prepare_optimization(adj,opt,spokes,system,target_phase)
% function opt2=prepare_optimization(adj,opt,spokes,system,target_phase)

opt2=opt;

% non-zero pixels
if strcmpi(opt2.display,'on')
    figure; imagesc(adj.roi); axis image; title('Optimization ROI'); axis off;
end

% non-zero voxels
opt2.ind=find(adj.roi>0);
opt2.nnonzeropixels=size(opt2.ind,1);
[indx indy indz]=ind2sub( [adj.nx adj.ny adj.nz],opt2.ind );
[tmpx tmpy tmpz]=ndgrid(adj.xs,adj.ys,adj.zs);
opt2.nonzeropixels=[indx indy indz tmpx(opt2.ind) tmpy(opt2.ind) tmpz(opt2.ind)];

% target magnetization
opt2.mtt=ones(opt2.nnonzeropixels,1)*sin( opt2.tfa/180.0*pi );
opt2.mttimg=zeros(adj.nx,adj.ny,adj.nz);
opt2.mttimg(opt2.ind)=opt2.mtt;
if ~isempty(target_phase)
    opt2.mttimg=opt2.mttimg .* exp(1j*target_phase);
    opt2.mtt=opt2.mttimg(opt2.ind);
end

% B0 map
if strcmpi(opt2.display,'on')
    figure; imagesc(adj.b0map); axis image; title('B0 map [Hz]'); axis off; colorbar
end
opt2.B0_=adj.b0map(opt2.ind);

% read B1 maps
nfigs=ceil(sqrt(system.ncoils));

if strcmpi(opt2.display,'on')
    h1=figure; h2=figure;
end
opt2.b1maps_=zeros( opt2.nnonzeropixels,system.ncoils );
for chn=1:system.ncoils
    opt2.b1maps_(:,chn)=adj.b1maps( chn,opt2.ind );        
end

if strcmpi(opt2.display,'on')
    display_nimages( abs( permute(adj.b1maps,[2 3 1]) ) );
    axis image; axis off; colormap(hot); colorbar;
    title('Amplitude of B1 maps [T/V]');
    
    display_nimages( 180/pi*angle( permute(adj.b1maps,[2 3 1]) ) );
    axis image; axis off; colormap(hot); colorbar; caxis([-180 180]); 
    title('Phase of B1 maps [deg.]');
end


% % determine regions of influence of the different coils
% opt2.ind_RofInf=cell(system.ncoils,1);
% if strcmpi(opt2.display,'on')
%     h3=figure;        
%     tmp=zeros(adj.nx,adj.ny,adj.nz);
% end   
% 
% for i=1:system.ncoils
%     maxb1=max(abs(opt2.b1maps_(:,i)));
%     opt2.ind_RofInf{i}=find( squeeze(abs(opt2.b1maps(i,:,:,:)))>(maxb1*0.5) );
%     if strcmpi(opt2.display,'on')
%         tmp(:)=0;
%         tmp(opt2.ind_RofInf{i})=1;
%         subplot(nfigs,nfigs,i);
%         imagesc(mask+tmp); axis image; axis off; colormap(hot);
%     end    
%  
% end
% 
% if strcmpi(opt2.display,'on')
%     figure(h3);
%     axes('Units','Normal','Position',[.075 .075 .85 .85],'Visible','off'); set(get(gca,'Title'),'Visible','on'); title('Regions of influence of the coils');
% end
%     
    
    
    
    
    
    
    
    


















