

function [npixels nspokes nchannels nconst x lambdas mtarget sm const f0hess]=read_matrices_dump(filepath)
% function [npixels nspokes nchannels nconst x lambdas mtarget sm const f0hess]=read_matrices_dump(filepath)


file=fopen(filepath,'r');

% parameters
tline=fgets(file); tline=fgets(file);
tline=fgets(file); npixels=tline_to_param(tline,21,size(tline,2)-2);
tline=fgets(file); nspokes=tline_to_param(tline,21,size(tline,2)-2);
tline=fgets(file); nchannels=tline_to_param(tline,23,size(tline,2)-2);
tline=fgets(file); nconst=tline_to_param(tline,36,size(tline,2)-2);

% vector of unknows
tline=fgets(file); tline=fgets(file);
x=zeros(2*nspokes*nchannels,1);
for i=1:nspokes*nchannels
    tmp=fscanf(file,'%e',2);
    x(i)=tmp(1);  % real part
    x(i+nspokes*nchannels)=tmp(2);  % imaginary part
end

% Lagrange variables
tline=fgets(file); tline=fgets(file); tline=fgets(file);
lambdas=zeros(nconst,1);
for i=1:nconst
    lambdas(i,1)=fscanf(file,'%e',1);
end

% target magnetization
tline=fgets(file); tline=fgets(file); tline=fgets(file);
mtarget=zeros(npixels,1);
for i=1:npixels
    tmp=fscanf(file,'%e',2);
    mtarget(i)=tmp(1) + 1j*tmp(2);
end

% system matrix
tline=fgets(file); tline=fgets(file); tline=fgets(file);
sm=zeros(npixels,nspokes*nchannels);
for i=1:npixels
    tmp=fscanf(file,'%e',2*nspokes*nchannels);
    for j=1:nspokes*nchannels
        sm(i,j)=tmp(2*(j-1)+1) + 1j*tmp(2*(j-1)+2);
    end
end

% constraints
tline=fgets(file); tline=fgets(file); tline=fgets(file);
const=zeros(nconst,nchannels,nchannels);
for n=1:nconst
    tline=fgets(file);
    for i=1:nchannels
        tmp=fscanf(file,'%e',2*nchannels);
        for j=1:nchannels
            const(n,i,j)=tmp(2*(j-1)+1) + 1j*tmp(2*(j-1)+2);
        end
    end
    tline=fgets(file);
end

% Hessian of the main function
tline=fgets(file); tline=fgets(file);
f0hess=zeros(2*nchannels*nspokes,2*nchannels*nspokes);
for i=1:2*nchannels*nspokes
    tmp=fscanf(file,'%e',2*nchannels*nspokes);
    for j=1:2*nchannels*nspokes
        f0hess(i,j)=tmp(j);
    end
end

fclose(file);



