

function spokes2=time_shift_sinc_profiles(spokes,deltat,system)
% function spokes2=time_shift_sinc_profiles(spokes,deltat,system)

spokes2=spokes;

nchannels=size(deltat,1)/spokes.nspokes;
gamma=42.576*1e6;

N=spokes2.ntimesperspoke;
omega=gamma*(spokes.Gss)*(spokes2.sthick);

times=([1:N]'-0.5-N/2)*system.deltat;
ind_rf=find(spokes2.mask_rf(1:N)>0);
Nrf=ind_rf(end)-ind_rf(1);
Trf=Nrf*system.deltat - 2*spokes2.deltat_max;

spokes2.sinc=zeros(N,nchannels,spokes.nspokes);
spokes2.Dsinc=zeros(N,nchannels,spokes.nspokes);
for i=1:nchannels
    for j=1:spokes.nspokes
        x=omega*(times-deltat(i+(j-1)*nchannels));
        
        f1=sinc(x);
        f2=rect( (times-deltat(i+(j-1)*nchannels))/Trf );    
        f3=0.54 + 0.46*cos( 2*pi*(times-deltat(i+(j-1)*nchannels))/Trf );  % hanning window
        
        df1=pi*omega*( cos(pi*x)./(pi*x)-sin(pi*x)./((pi*x).^2) );
        df1( find(abs(x)==0) )=0;
        
        df3=-2*pi*0.46/Trf*sin( 2*pi*(times-deltat(i+(j-1)*nchannels))/Trf );
        
        spokes2.sinc(:,i,j)=f1.*f2.*f3;    
        spokes2.Dsinc(:,i,j)=df1.*f2.*f3 + f1.*f2.*df3;    
    end
end

% correlation matrix
spokes2.sinc_corr_mat=cell(spokes.nspokes);
spokes2.Dsinc_corr_mat=cell(spokes.nspokes);
spokes2.C=zeros(nchannels*spokes.nspokes);
spokes2.DC=zeros(nchannels*spokes.nspokes);
for i=1:spokes.nspokes
    spokes2.sinc_corr_mat{i}=spokes2.sinc(:,:,i)'*spokes2.sinc(:,:,i) / spokes2.ntimes;
    spokes2.Dsinc_corr_mat{i}=spokes2.sinc(:,:,i)'*spokes2.Dsinc(:,:,i) / spokes2.ntimes;
    spokes2.D2sinc_corr_mat{i}=spokes2.Dsinc(:,:,i)'*spokes2.Dsinc(:,:,i) / spokes2.ntimes;
    
    ind=[1:nchannels]+(i-1)*nchannels;
    spokes2.C(ind,ind)=spokes2.sinc_corr_mat{i};
    spokes2.DC(ind,ind)=spokes2.Dsinc_corr_mat{i};
    spokes2.D2C(ind,ind)=spokes2.D2sinc_corr_mat{i};    
end

