

function write_and_display_bloch_simulation(mx,my,mz,opt)
% function write_and_display_bloch_simulation(mx,my,mz,opt)

mtimg=mx+1j*my;
faimg=real( asin(abs(mtimg))/pi*180.0 );
phaimg=angle(mtimg);
write_fdata( faimg,sprintf('%s/bloch_simu_%d_%d_%d_fa',opt.resdir,opt.nx,opt.ny,opt.nz) );
write_fdata( phaimg,sprintf('%s/bloch_simu_%d_%d_%d_pha',opt.resdir,opt.nx,opt.ny,opt.nz) );

if strcmpi(opt.display,'on')
    figure;
    subplot(2,1,1); imagesc(faimg); colormap(hot); caxis([0 opt.tfa*1.5]); colorbar; axis image; axis off; title('Flip angle map [deg.], Bloch sim.');
    subplot(2,1,2); imagesc(phaimg); colormap(hot); caxis([-pi pi]); axis image; axis off; colorbar; title('Phase map [rad.], Bloch sim.');
end



