


function write_and_display_bloch_simulation_z(zs,mxz,myz,mzz,opt)
% function write_and_display_bloch_simulation_z(zs,mxz,myz,mzz,opt)

% write on file
arr_dump=zs;
mt=(mxz.^2+myz.^2).^0.5;
arr_dump=[ arr_dump mt/max(max(mt)) ];
arr_dump=[ arr_dump atan2(myz,mxz) ];
dlmwrite([opt.resdir '/slice_profile.txt'],arr_dump,'\t');

SP=mt/max(max(mt));
save 'slice_profile.mat' 'zs' 'SP';

% display
nchannels=size(mxz,2);
if strcmpi(opt.display,'on')
    f=figure;
    subplot(1,2,1);
    plot(zs*100,arr_dump(:,2:2+nchannels-1),'LineWidth',2);
    xlabel('z [cm]'); title('Magnitude [a.u.]');
    axis([min(zs)*100 max(zs)*100 0 1.2]);

    subplot(1,2,2);
    plot(zs*100,arr_dump(:,2+nchannels:end),'LineWidth',2);
    xlabel('z [cm]'); title('Phase [rad.]');
    axis([min(zs)*100 max(zs)*100 -pi pi]);
end

















