

function rf=write_and_display_pulse(x,opt,spokes,system)
% function rf=write_and_display_pulse(x,opt,spokes,system)

file=fopen('pulse.txt','w');
% for j=1:spokes.nspokes
%     fprintf(file,'spoke #%d mag.\tspoke #%d pha.\t',j,j);
% end
% for i=1:system.ncoils
%     fprintf(file,'\n');
%     for j=1:spokes.nspokes
% 		fprintf(file,'%e\t%e\t',abs(x(i+(j-1)*system.ncoils)),angle(x(i+(j-1)*system.ncoils))/pi*180.0);
%     end
% end

% fprintf(file,'\ntime (s)\tgx (T/m)\tgy (T/m)\tgz (T/m)\t\tsx (T/m/s)\tsy (T/m/s)\tsz (T/m/s)\tkx (1/m)\tky (1/m)\tkz (1/m)');
for j=1:system.ncoils
    % fprintf(file,'\trf_%d_mag (V)\trf_%d_pha (deg.)',j,j);
end
time=[1:spokes.ntimes]'*system.deltat;
rf=zeros(spokes.ntimes,system.ncoils);
for i=1:spokes.ntimes
    % fprintf(file,'\n');
    if i==1
        sr=[0 0 0];
    else
        sr=(spokes.g(i,:)-spokes.g(i-1,:))/system.deltat;
    end
	% fprintf(file,'%e\t%e\t%e\t%e\t%e\t%e\t%e\t%e\t%e\t%e',time(i),spokes.g(i,:),sr,spokes.k(i,:));
    for j=1:system.ncoils
        rf(i,j)=get_rf(x,i,j,system.ncoils,spokes);
        % fprintf(file,'\t%e\t%e',abs(rf(i,j)),angle(rf(i,j))/pi*180.0);
    end
end
fclose(file);

if strcmpi(opt.display,'on')
    figure;
    subplot(2,1,1); plot(time,abs(rf)); xlabel('time (s)'); title('RF voltage amplitudes (V)');
    subplot(2,1,2); plot(time,angle(rf)/pi*180.0); xlabel('time (s)'); title('RF voltage phases (deg.)');
end

% write_pulse_ini_file(rf,'pulse.ini',spokes,opt,system);

% write ini file
options.Oversampling=1;
options.NominalFlipAngle=opt.tfa;
% options.NOMFLIPANGLE=opt.tfa;
options.RFPULSE_ID=0;
options.VERBOSE=0;
options.GRADRASTERTIME=system.deltat*1e6;  % us
grad=[spokes.g(:,2) -spokes.g(:,1) -spokes.g(:,3)]*1e3;  % swap gx and gy and convert T/m -> mT/m (the delayed version of the gradienst is sent to the scanner)

% save ini file
grad_over_samp_fac=1e-5/system.deltat;
if ceil(grad_over_samp_fac)~=grad_over_samp_fac
    warning('The oversampling factor is not integer, this will cause the ini pulse to be unplayable on the scanner.');
else
    options.GRADRASTERTIME=system.deltat*grad_over_samp_fac*1e6;  % 10 us
    options.FACTOROVERSAMPLE=grad_over_samp_fac;
    grad=grad(1:grad_over_samp_fac:end,:);
end

% save_pTXRFPulse_toINI(grad,reshape(rf,system.ncoils*opt.ntimes,1),[],options);

options.type= 'SBBExcitationPtx';
options.fileName='pTXArbitrary';
options.PulseName= 'pTx';
options.Comment = 'pTx pulse';
% create_pTXRFPulse2( grad.',rf', options);  % save the conjugate of RF pulse

    
    
function rf=get_rf(x,time,channel,nchannels,spokes)

rf=0.0;
sp=spokes.time_to_spoke(time);
if time>0 && time<=spokes.ntimes && sp>0 && channel>0 && channel<=nchannels
    rf=x(channel + (sp-1)*nchannels)*spokes.sinc(spokes.time_to_sinc_time(time),channel,sp);
end


    

function write_pulse_ini_file(rf,filepath,spokes,opt,system)

file=fopen(filepath,'w');
nchannels=size(rf,2);
ntimes=size(rf,1);

% global parameter section
fprintf(file,'\n#----------\n');
fprintf(file,'[pTXPulse]\n');
fprintf(file,'\n');
fprintf(file,'NUsedChannels    = %d\n',nchannels);
fprintf(file,'DimRF            = 2\n');
fprintf(file,'DimGradient      = 3\n');
fprintf(file,'MaxAbsRF         = %g\t\t # scaling for RF amplitude\n',max(max(abs(rf))));
fprintf(file,'InitialPhase     = 0.0\n');	
fprintf(file,'Asymmetry        = 0.5\n');
fprintf(file,'\n');
fprintf(file,'PulseName        = %s\t\t #standard RF pulse parameters\n',filepath);
fprintf(file,'Family           = pTX\n');
fprintf(file,'Comment          = pTX\n');
fprintf(file,'NominalFlipAngle = %g\n',opt.tfa);
fprintf(file,'Samples          = %d\n',ntimes);
fprintf(file,'DwellTime          = %e\n',system.deltat);
fprintf(file,'AmplInt          = 100.0\n');
fprintf(file,'AbsInt           = 100.0\n');
fprintf(file,'PowerInt         = 100.0\n');
fprintf(file,'MinSlice         = 1.0\n');
fprintf(file,'MaxSlice         = 1.0\n');
fprintf(file,'RefGrad          = 1.0\n');
fprintf(file,'\n');

% SAR section
fprintf(file,'\n#----------\n');
fprintf(file,'[TXA_SAR_SECTION]\n');
fprintf(file,'\n');
fprintf(file,'IsPulseSARchecked = 0\n');

fprintf(file,'TX1_PALI_LIMIT_PEAK=\"0\"\n');
fprintf(file,'TX1_PALI_LIMIT_10SEC=\"0\"\n');
fprintf(file,'TX1_PALI_LIMIT_6MIN=\"0\"\n\n');

fprintf(file,'TX2_PALI_LIMIT_PEAK=\"0\"\n');
fprintf(file,'TX2_PALI_LIMIT_10SEC=\"0\"\n');
fprintf(file,'TX2_PALI_LIMIT_6MIN=\"0\"\n\n');

fprintf(file,'TX3_PALI_LIMIT_PEAK=\"0\"\n');
fprintf(file,'TX3_PALI_LIMIT_10SEC=\"0\"\n');
fprintf(file,'TX3_PALI_LIMIT_6MIN=\"0\"\n\n');

fprintf(file,'TX4_PALI_LIMIT_PEAK=\"0\"\n');
fprintf(file,'TX4_PALI_LIMIT_10SEC=\"0\"\n');
fprintf(file,'TX4_PALI_LIMIT_6MIN=\"0\"\n\n');

fprintf(file,'TX5_PALI_LIMIT_PEAK=\"0\"\n');
fprintf(file,'TX5_PALI_LIMIT_10SEC=\"0\"\n');	
fprintf(file,'TX5_PALI_LIMIT_6MIN=\"0\"\n\n');

fprintf(file,'TX6_PALI_LIMIT_PEAK=\"0\"\n');
fprintf(file,'TX6_PALI_LIMIT_10SEC=\"0\"\n');
fprintf(file,'TX6_PALI_LIMIT_6MIN=\"0\"\n\n');

fprintf(file,'TX7_PALI_LIMIT_PEAK=\"0\"\n');
fprintf(file,'TX7_PALI_LIMIT_10SEC=\"0\"\n');
fprintf(file,'TX7_PALI_LIMIT_6MIN=\"0\"\n\n');

fprintf(file,'TX8_PALI_LIMIT_PEAK=\"0\"\n');
fprintf(file,'TX8_PALI_LIMIT_10SEC=\"0\"\n');
fprintf(file,'TX8_PALI_LIMIT_6MIN=\"0\"\n\n');

% gradient section
fprintf(file,'\n#----------\n');
fprintf(file,'[Gradient]\t # Gx\t Gy\t Gz\t [mT/m]\n');
fprintf(file,'\n');
fprintf(file,'GradientSamples   =  %d\n',ntimes);
fprintf(file,'MaxAbsGradient[0] =  %f\t %f\t %f\t\t # scaling for G amplitude\n',max(abs(spokes.g(:,1)))*1e3,max(abs(spokes.g(:,2)))*1e3,max(abs(spokes.g(:,3)))*1e3);  % T/m -> mT/m
fprintf(file,'GradRasterTime    =  %f   # [us]\n',system.deltat*1e6);  %  s -> us
fprintf(file,'\n');

for i=1:ntimes
    fprintf(file,'G[%d]= %f\t %f\t %f\n',i-1,spokes.g(i,1)*1e3,spokes.g(i,2)*1e3,spokes.g(i,3)*1e3);  %  T/m -> mT/m
end

% rf section
for j=1:nchannels
    fprintf(file,'\n#----------\n');
    fprintf(file,'[pTXPulse_ch%d]\t # Amplitude\t Phase\n',j-1);
    fprintf(file,'\n');
    for i=1:ntimes
        mag=abs(rf(i,j));
        pha=angle(rf(i,j));
        if pha<0 
            pha=pha+2*pi;
        end
        fprintf(file,'RF[%d]= %f\t %f\n',i-1,mag,pha);
    end
end
fprintf(file,'\n#EOF\n');
fclose(file);







    
    
    
    
    
    
    
